#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/*
 * Loetakse failist string ja kontrollitakse, kas string on palindroom
 * Kontroll teostatakse stackist lugemisega
 * */

const char INPUTFILENAME[] = "data3.in";

typedef struct STACK{
    char c;
    struct STACK *pNext;
}STACK;

int file_check(FILE*);
STACK *read_file(FILE*, char**);
int isempty(STACK*);
char pop(STACK*);
STACK *push(STACK*, char);
void read_all(STACK*, char*);

int main(void){
    FILE *F = fopen(INPUTFILENAME, "r");
    char *str = malloc(sizeof(char)*2);
    char **strptr = &str;
    if(!file_check(F)){
        printf("File %s not found\n", INPUTFILENAME);
        return 1;
    }
    STACK *stack = read_file(F, strptr);
    if(isempty(stack)){
        printf("Stack is empty\n");
        return 2;
    }
    read_all(stack, *strptr);
    return 0;
}

int file_check(FILE *F){
    if(F != NULL)
        return 1;
    return 0;
}

STACK *read_file(FILE *F, char **strptr){
	char *str = *strptr;
	int slen = 2, i = 0;
    STACK *stackTop = NULL;
    char buf;
    while(fscanf(F, "%c", &buf) != EOF){
		if((buf >= 65 && buf <= 90) || (buf >= 97 && buf <= 122)){
			if (i+1 < slen){
				str[i] = buf;
			}else{
				str = realloc(str, sizeof(char)*slen*2);
				slen *= 2;
				str[i] = buf;
			}
			i++;
			stackTop = push(stackTop, buf);
		}
    }
    str[i] = '\0';
    return stackTop;
}

int isempty(STACK *stack){
    if(stack != NULL)
        return 0;
    return 1;
}


STACK *push(STACK *top, char c){
    STACK *temp = (STACK*)malloc(sizeof(STACK));
    temp->c = c;
    temp->pNext = top;
    return temp;
}

char pop(STACK *stack){
    return stack->c;
}

void read_all(STACK *stack, char *str){
	int i = 0;
	char *uus = malloc(sizeof(char)*strlen(str));
	printf("%s\n", str);
    while(!isempty(stack)){
        char temp = pop(stack);
        printf("%c", temp);
        uus[i] = temp;
        i++;
        STACK *lastNode = stack;
        stack = stack->pNext;
        free(lastNode);
    }
    if(strcmp(str, uus))
		printf("\nString %s ei ole palindroom\n", uus);
	else
		printf("\nString %s on palindroom\n", uus);
}








